//
//  DIAImage.m
//  dukePhotoUpload
//
//  Created by ctbrown5 on 4/18/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DIAImage.h"
#import <QuartzCore/QuartzCore.h>


@implementation DIAImage


-(id)initwithImage:(UIImage *)initialImage{
    
    [self init];
    self.photo = initialImage;
    [self initializeDIAImage];
    return self;
    
}

-(void)initializeDIAImage{
    
    self.backgroundColor = [UIColor whiteColor];
    
    [self.layer setBorderColor:[[UIColor blackColor] CGColor]];
    [self.layer setBorderWidth:1.0];
    [self.layer setCornerRadius:3.0];
    
    UIImageView *thePhoto = [[UIImageView alloc]initWithImage: self.photo ];
    CGFloat width =[[UIScreen mainScreen] bounds].size.width;
    
    thePhoto.frame = CGRectMake(5, 5, width/5 - 10, width/5 -10);
    self.frame =CGRectMake(0, 0, width/5, width/5 + 25);
    
    UILabel *textLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, self.frame.size.height - 30, thePhoto.frame.size.width, 30)];
    textLabel.text = @"text here";
    [textLabel setBackgroundColor:[UIColor clearColor]];
    [textLabel setTextAlignment:UITextAlignmentCenter];
    [self addSubview:textLabel];
    
    self.DIAImageContent = thePhoto;
    [self addSubview:thePhoto];
    
    self.userInteractionEnabled = TRUE;
    [self initializeGestureRecognizers];

}


-(void)initializeGestureRecognizers {
    

    UITapGestureRecognizer *tapGestureRecognizer = 
        [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleDoubleTap:)];
    tapGestureRecognizer.numberOfTapsRequired = 1;
    tapGestureRecognizer.numberOfTouchesRequired = 1;
    [self addGestureRecognizer:tapGestureRecognizer];
    
    UIPanGestureRecognizer *panGestureRecognizer = 
        [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(handlePan:)];

    [self addGestureRecognizer:panGestureRecognizer];
    
    UIPinchGestureRecognizer *pinchGestureRecongnizer = 
        [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(handlePinch:)];
    [self addGestureRecognizer:pinchGestureRecongnizer];
    
    UIRotationGestureRecognizer *rotGestureRecognizer =
        [[UIRotationGestureRecognizer alloc] initWithTarget:self action:@selector(handleRotate:)];
    [self addGestureRecognizer:rotGestureRecognizer];
}

- (void)handleDoubleTap:(id)sender{
//    Note this is currently set to single tap, but I didn't change the 
    [self.superview bringSubviewToFront:self];
    
}

- (void)handlePan:(UIPanGestureRecognizer *)recognizer {
    
    
    CGPoint translation = [recognizer translationInView: self.superview];
    recognizer.view.center = CGPointMake(recognizer.view.center.x + translation.x, 
                                         recognizer.view.center.y + translation.y);
    [recognizer setTranslation:CGPointMake(0, 0) inView: self];
    
    [self.superview bringSubviewToFront:self];
}

- (void)handlePinch:(UIPinchGestureRecognizer *)recognizer {    
    
    recognizer.view.transform = CGAffineTransformScale(recognizer.view.transform, recognizer.scale, recognizer.scale);
    recognizer.scale = 1;    
    [self.superview bringSubviewToFront:self];
}

- (void)handleRotate:(UIRotationGestureRecognizer *)recognizer {    
    recognizer.view.transform = CGAffineTransformRotate(recognizer.view.transform, recognizer.rotation);

    recognizer.rotation = 0;    
    [self.superview bringSubviewToFront:self];
}



@end
