//
//  DIAViewController.m
//  dukePhotoUpload
//
//  Created by Ross Tucker on 4/4/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DIAViewController.h"
#import "DIAImage.h"
#import <QuartzCore/QuartzCore.h>

@implementation DIAViewController
@synthesize buttonImage;

@synthesize photo1,myLabel,startPoint1,myPopover;


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a 
    
}

- (void)viewDidUnload
{
    [self setButtonImage:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = 
    
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"dark-metal-texture.jpg"]];
    

    
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}



- (void)animateImageEntry:(DIAImage*)im{
    
    CGRect viewBounds = self.view.bounds;
    CGPoint rpoint = [self randomPoint:viewBounds];
    
    im.center = CGPointMake(-100, 100);
    [self.view addSubview:im];
    
    [UIView animateWithDuration:1 animations:^{
        
        im.center = rpoint;
        im.transform = CGAffineTransformRotate(im.transform, [self randomTilt]);
    }];
    
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info{
    
    UIImage *newPhoto = [info objectForKey:UIImagePickerControllerOriginalImage];
    
    DIAImage *newDIAImage = [[DIAImage alloc] initwithImage:newPhoto];
    [self.view addSubview:newDIAImage];
    
    [self dismissViewControllerAnimated:YES completion:^{}];
}

- (CGPoint)randomPoint:(CGRect)rectangle{
    
    float maxX = CGRectGetMaxX(rectangle);
    float minX = CGRectGetMinX(rectangle);
    float maxY = CGRectGetMaxY(rectangle);
    float minY = CGRectGetMinY(rectangle);
    
    float randX = (float)rand() / RAND_MAX * (maxX-minX-maxX/5) + minX;
    float randY = (float)rand() / RAND_MAX * (maxY-minY-maxX/5) + minY;
    
    return CGPointMake(randX, randY);
    
}

- (UIImage *)randomImage:(int)numImages{
    
    int x = arc4random() % numImages + 1;
    NSMutableString *string1 = [NSMutableString stringWithString: @"Photo.jpg"];
    [string1 insertString: [NSString stringWithFormat:@"%d", x] atIndex: 5];
    return [UIImage imageNamed:string1];   
}

- (CGFloat)randomTilt{
    float randTilt = (float)rand() / RAND_MAX * 0.2 - 0.1;
    return (CGFloat) randTilt;
}

- (IBAction)takePhoto:(id)sender {
    buttonImage.image = [UIImage imageNamed:@"Unclicked.png"];
    
//    If we have a camera, get a picture. Otherwise pick a random photo from the directory.
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        UIImagePickerController *pickerController = [[UIImagePickerController alloc] init];
        pickerController.delegate = self;
        pickerController.sourceType = UIImagePickerControllerSourceTypeCamera;
        self.modalPresentationStyle = UIModalPresentationFullScreen;
        [self presentViewController:pickerController animated:YES completion:^{}];
    }else{
        DIAImage *newDIAImage = [[DIAImage alloc] initwithImage:[self randomImage:4]];
        [self animateImageEntry:newDIAImage];
        
        //[self.view addSubview:newDIAImage];
        
    }
}

- (IBAction)buttonDepressed:(id)sender{
        buttonImage.image = [UIImage imageNamed:@"Clicked.png"];
   }


@end
